library flutter_udstretchbox;

import 'package:flutter/widgets.dart';
import 'package:provider/provider.dart';
import 'package:stretchbox/model/stretched_box_state.dart';
import 'package:stretchbox/vm/stretched_box_viewmodel.dart';

/// 视图 StretchboxWidget.
/// 提供 状态管理，需要外部传入：正常场景下的Widget以及展开状态下的Widget
// ignore: must_be_immutable
class StretchedBoxWidget extends StatelessWidget {
  StretchedBoxViewModel stretchboxViewModel;
  final bool defaultStretchState;
  final Widget normalChild;
  final Widget expandChild;

  StretchedBoxWidget({
    Key key,
    this.defaultStretchState,
    this.normalChild,
    this.expandChild,
  }) : super(key: key) {
    stretchboxViewModel = StretchedBoxViewModel();
  }

  @override
  Widget build(BuildContext context) {
    return ChangeNotifierProvider(
      create: (_) => stretchboxViewModel,
      child: buildContentWidget(context, stretchboxViewModel),
    );
  }

  Widget buildContentWidget(
      BuildContext context, StretchedBoxViewModel stretchboxViewModel) {
    return Selector<StretchedBoxViewModel, StretchedBoxState>(
        selector: (context, value) => stretchboxViewModel?.stretchState,
        builder: (BuildContext context, value, Widget child) {
          if (value == StretchedBoxState.normal) {
            return this.normalChild;
          } else {
            return this.expandChild;
          }
        });
  }
}
